(function (d3) {
  'use strict';

  const svg = d3.select('svg');

  const width = +svg.attr('width');
  const height = +svg.attr('height');
  let global_data;
  let xValue;
  let yValue;
  let lastX = 'sepal length';
  let lastY = 'sepal length';
  let xval = 'sepal width';
  let yval = 'sepal width';
  let xAxisLabel = 'sepal length';
  let yAxisLabel = 'sepal width';
  var xclass=document.getElementById('flowerfeatureX');
  var yclass=document.getElementById('flowerfeatureY');

  function repeat_check(){
    xValue = global_data['sepal length'];
    yValue = global_data['sepal width'];
  	var xindex=xclass.selectedIndex;
    var yindex=yclass.selectedIndex;
  	xval = xclass.options[xindex].text;
    yval = yclass.options[yindex].text;
  	setTimeout(repeat_check, 500);

    if(lastX != xval || lastY != yval){
    	render(global_data, xval, yval);
    }
    lastX = xval;
    lastY = yval;
  }


  const render = (data, xval, yval) => {
    svg.selectAll("*").remove();
    const title = 'Iris Sctter Plot';
    
    //xValue = d => d['sepal length'];
    //const xAxisLabel = 'sepal length';
    if(xval == 'sepal length'){
    	xValue = d => d['sepal length'];
      xAxisLabel = 'sepal length';
    }else if(xval == 'sepal width'){
    	xValue = d => d['sepal width'];
      xAxisLabel = 'sepal width';
    }else if(xval == 'petal length'){
    	xValue = d => d['petal length'];
      xAxisLabel = 'petal length';
    }else {
    	xValue = d => d['petal width'];
      xAxisLabel = 'petal width';
    }
    
    //const yValue = d => d['sepal width'];
    //const yAxisLabel = 'sepal width';
    if(yval == 'sepal length'){
    	yValue = d => d['sepal length'];
      yAxisLabel = 'sepal length';
    }else if(yval == 'sepal width'){
    	yValue = d => d['sepal width'];
      yAxisLabel = 'sepal width';
    }else if(yval == 'petal length'){
    	yValue = d => d['petal length'];
      yAxisLabel = 'petal length';
    }else {
    	yValue = d => d['petal width'];
      yAxisLabel = 'petal width';
    }
    
    const circleRadius = 10;
    
    const KPI = d => {
    	if(d == 'Iris-setosa') return "#E6842A";
      else if(d == 'Iris-versicolor') return '#137B80';
    	else return "#8E6C8A";
  	};
    
    const margin = { top: 45, right: 120, bottom: 175, left: 120 };
    const innerWidth = width - margin.left - margin.right;
    const innerHeight = height - margin.top - margin.bottom;
    
    const xScale = d3.scaleLinear()
      .domain(d3.extent(data, xValue))
      .range([0, innerWidth])
      .nice();
    
    const yScale = d3.scaleLinear()
      .domain(d3.extent(data, yValue))
      .range([innerHeight, 0])
      .nice();
    
    const g = svg.append('g')
      .attr('transform', `translate(${margin.left},${margin.top})`);
    
    const xAxis = d3.axisBottom(xScale)
      .tickSize(-innerHeight)
      .tickPadding(15);
    
    const yAxis = d3.axisLeft(yScale)
      .tickSize(-innerWidth)
      .tickPadding(10);
    
    const yAxisG = g.append('g').call(yAxis);
    yAxisG.selectAll('.domain').remove();
    
    yAxisG.append('text')
        .attr('class', 'axis-label')
        .attr('y', -70)
        .attr('x', -innerHeight / 2)
        .attr('fill', 'black')
        .attr('transform', `rotate(-90)`)
        .attr('text-anchor', 'middle')
        .text(yAxisLabel);
    
    const xAxisG = g.append('g').call(xAxis)
      .attr('transform', `translate(0,${innerHeight})`);
    
    xAxisG.select('.domain').remove();
    
    xAxisG.append('text')
        .attr('class', 'axis-label')
        .attr('y', 75)
        .attr('x', innerWidth / 2)
        .attr('fill', 'black')
        .text(xAxisLabel);
    
    g.selectAll('circle').data(data)
      .enter().append('circle')
        .attr('cy', d => yScale(yValue(d)))
        .attr('cx', d => xScale(xValue(d)))
        .attr('r', circleRadius)
        .style("fill", d => {return KPI(d.class); });
    
    g.append('text')
        .attr('class', 'title')
        .attr('y', -10)
    		.attr('x', 247)
        .text(title);
  };

  d3.csv('iris.csv')
    .then(data => {
      data.forEach(d => {
        d['sepal length'] = +d['sepal length'];
        d['sepal width'] = +d['sepal width'];
        d['petal length'] = +d['petal length'];
        d['petal width'] = +d['petal width'];
      });
    	global_data = data;
      render(data, xval, yval);
    	repeat_check();
    });

}(d3));